## grantlee5 5.3.1

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(grantlee_examples)

include(ExternalProject)

if (IS_ABSOLUTE ${CMAKE_PREFIX_PATH})
  set(prefixPath ${CMAKE_PREFIX_PATH})
else()
  set(prefixPath ${CMAKE_BINARY_DIR}/${CMAKE_PREFIX_PATH})
endif()

ExternalProject_Add(books
  SOURCE_DIR ${CMAKE_SOURCE_DIR}/books
  INSTALL_COMMAND ""
  CMAKE_ARGS
    -DCMAKE_PREFIX_PATH=${prefixPath}
)
ExternalProject_Add(codegen
  SOURCE_DIR ${CMAKE_SOURCE_DIR}/codegen
  INSTALL_COMMAND ""
  CMAKE_ARGS
    -DCMAKE_PREFIX_PATH=${prefixPath}
  DEPENDS books
)

if (NOT GRANTLEE_BUILD_WITH_QT6)
  ExternalProject_Add(contacts
    SOURCE_DIR ${CMAKE_SOURCE_DIR}/contacts
    INSTALL_COMMAND ""
    CMAKE_ARGS
      -DCMAKE_PREFIX_PATH=${prefixPath}
    DEPENDS codegen
  )

  ExternalProject_Add(htmlapps
    SOURCE_DIR ${CMAKE_SOURCE_DIR}/htmlapps
    INSTALL_COMMAND ""
    CMAKE_ARGS
      -DCMAKE_PREFIX_PATH=${prefixPath}
    DEPENDS contacts
  )
endif()

ExternalProject_Add(textedit
  SOURCE_DIR ${CMAKE_SOURCE_DIR}/textedit
  INSTALL_COMMAND ""
  CMAKE_ARGS
    -DCMAKE_PREFIX_PATH=${prefixPath}
  DEPENDS htmlapps
)

=== textdocument/CMakeLists.txt ===

if (GRANTLEE_BUILD_WITH_QT6)
    find_package(Qt6Gui 6.0.0 REQUIRED)
else()
    find_package(Qt5Gui 5.2.0 REQUIRED)
endif()

add_subdirectory(lib)

if (BUILD_TESTS)
  add_subdirectory(tests)
endif()

=== examples/books/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(books_grantlee)

find_package(Grantlee5 REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

get_property(Grantlee_PLUGIN_DIR TARGET Grantlee5::defaulttags PROPERTY LOCATION)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)

configure_file(grantlee_paths.h.cmake ${PROJECT_BINARY_DIR}/grantlee_paths.h)

find_package(Qt5Widgets REQUIRED)
find_package(Qt5Sql REQUIRED)

add_executable(books
  main.cpp
  bookwindow.cpp
  bookwrapper.cpp
  bookdelegate.cpp
  books.qrc
)

target_link_libraries(
  books
  Grantlee5::Templates
)
if (GRANTLEE_BUILD_WITH_QT6)
    target_link_libraries(books
      Qt6::Widgets
      Qt6::Sql
    )
else()
    target_link_libraries(books
      Qt5::Widgets
      Qt5::Sql
    )
endif()

=== examples/codegen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(codegen_grantlee)

find_package(Grantlee5 REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

get_property(Grantlee_PLUGIN_DIR TARGET Grantlee5::defaulttags PROPERTY LOCATION)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)
get_filename_component(Grantlee_PLUGIN_DIR ${Grantlee_PLUGIN_DIR} PATH)

configure_file(grantlee_paths.h.cmake ${PROJECT_BINARY_DIR}/grantlee_paths.h)

qt5_add_resources(
  codegen_example_RCS_SRCS
  custom_tags.qrc
  OPTIONS -root "/plugins/grantlee/${Grantlee5_VERSION_MAJOR}.${Grantlee5_VERSION_MINOR}/"
)

add_executable(codegen
  codegen.qrc
  comboboxdelegate.cpp
  main.cpp
  methodmodel.cpp
  codegentableview.cpp
  designwidget.cpp
  propertytablewidget.cpp
  mainwindow.cpp
  ${codegen_example_RCS_SRCS}
)
target_compile_definitions(codegen PRIVATE QT_DISABLE_DEPRECATED_BEFORE=0)

find_package(Qt5Widgets REQUIRED)

target_link_libraries(
  codegen
  Grantlee5::Templates
)
if (GRANTLEE_BUILD_WITH_QT6)
    target_link_libraries(codegen
      Qt6::Widgets
    )
else()
    target_link_libraries(codegen
      Qt5::Widgets
    )
endif()

=== examples/contacts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(contacts_grantlee)

find_package(Grantlee5 REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

configure_file(grantlee_paths.h.cmake ${PROJECT_BINARY_DIR}/grantlee_paths.h)

add_executable(contacts_linguist
  main_linguist.cpp
  mainwindow.cpp
  contact.cpp
)
target_link_libraries(
  contacts_linguist
  Grantlee5::Templates
)

find_package(Qt5WebKitWidgets REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
target_link_libraries(
  contacts_linguist
  Qt5::WebKitWidgets
)
set(lupdate_exe Qt5::lupdate)
set(lrelease_exe Qt5::lrelease)

execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink "${PROJECT_SOURCE_DIR}/../../scripts" "${PROJECT_SOURCE_DIR}/scripts")

set( LINGUIST_TS_ARGS COMMAND "${CMAKE_SOURCE_DIR}/scripts/extract_strings_linguist.py"
  "${CMAKE_SOURCE_DIR}/themes/linguist/bashful/*.html"
  "${CMAKE_SOURCE_DIR}/themes/linguist/sneezy/*.html"
  "${CMAKE_SOURCE_DIR}/themes/linguist/sleepy/*.html"
  ">" "${CMAKE_BINARY_DIR}/output.cpp"
  COMMAND ${lupdate_exe} "${CMAKE_BINARY_DIR}/output.cpp" "-ts" )

set (CONTACTS_LOCALES "fr_FR" "de_DE" )

foreach(CONTACT_LOCALE ${CONTACTS_LOCALES})
    list(APPEND LINGUIST_TS_ARGS "${CMAKE_SOURCE_DIR}/${CONTACT_LOCALE}.ts" )
endforeach()

add_custom_target(linguist_ts
  ${LINGUIST_TS_ARGS}
    VERBATIM
)

foreach(CONTACT_LOCALE ${CONTACTS_LOCALES})
    list(APPEND _LINGUIST_QM_ARGS COMMAND ${lrelease_exe} "${CMAKE_SOURCE_DIR}/${CONTACT_LOCALE}.ts" "-qm" "${CMAKE_BINARY_DIR}/contacts_${CONTACT_LOCALE}.qm" )
endforeach()

add_custom_target(linguist_qm
  ${_LINGUIST_QM_ARGS}
)

=== templates/defaultfilters/CMakeLists.txt ===
add_library(grantlee_defaultfilters MODULE
  defaultfilters.cpp
  datetime.cpp
  integers.cpp
  lists.cpp
  logic.cpp
  misc.cpp
  stringfilters.cpp
)
set_property(TARGET grantlee_defaultfilters PROPERTY
    EXPORT_NAME defaultfilters
)
target_link_libraries(grantlee_defaultfilters PRIVATE
  Grantlee5::Templates
)
target_compile_features(grantlee_defaultfilters PRIVATE
  cxx_auto_type
)
grantlee_adjust_plugin_name(grantlee_defaultfilters)

install(TARGETS grantlee_defaultfilters
  EXPORT grantlee_targets
  LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
  COMPONENT Templates
)

=== templates/i18n/CMakeLists.txt ===
add_library(grantlee_i18ntags MODULE
  i18ntags.cpp
  i18n.cpp
  i18nc.cpp
  i18np.cpp
  i18ncp.cpp
  l10n_money.cpp
  l10n_filesize.cpp
  with_locale.cpp
)
set_property(TARGET grantlee_i18ntags PROPERTY
  EXPORT_NAME i18ntags
)
target_link_libraries(grantlee_i18ntags PRIVATE
  Grantlee5::Templates
)
target_compile_features(grantlee_i18ntags PRIVATE
  cxx_auto_type
)
grantlee_adjust_plugin_name(grantlee_i18ntags)

install(TARGETS grantlee_i18ntags 
  EXPORT grantlee_targets
  LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
  COMPONENT Templates
)

=== templates/lib/CMakeLists.txt ===

configure_file(grantlee_version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/grantlee_version.h)

set(Grantlee_PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR} )

configure_file(grantlee_config_p.h.cmake  ${CMAKE_CURRENT_BINARY_DIR}/grantlee_config_p.h)

set_source_files_properties(taglibraryinterface.h PROPERTIES
  SKIP_AUTOMOC TRUE
)

add_library(Grantlee_Templates SHARED
  abstractlocalizer.cpp
  cachingloaderdecorator.cpp
  customtyperegistry.cpp
  context.cpp
  engine.cpp
  filter.cpp
  filterexpression.cpp
  lexer.cpp
  metatype.cpp
  node.cpp
  nodebuiltins.cpp
  nulllocalizer.cpp
  outputstream.cpp
  parser.cpp
  qtlocalizer.cpp
  rendercontext.cpp
  safestring.cpp
  template.cpp
  templateloader.cpp
  textprocessingmachine.cpp
  typeaccessors.cpp
  util.cpp
  variable.cpp

  # Help IDEs find some non-compiled files.
  customtyperegistry_p.h
  engine_p.h
  exception.h
  grantlee_tags_p.h
  grantlee_templates.h
  lexer_p.h
  metaenumvariable_p.h
  nodebuiltins_p.h
  nulllocalizer_p.h
  pluginpointer_p.h
  statemachine_p.h
  taglibraryinterface.h
  template_p.h
  textprocessingmachine_p.h
  token.h
  typeaccessor.h
)
add_library(Grantlee5::Templates ALIAS Grantlee_Templates)
generate_export_header(Grantlee_Templates)
set_property(TARGET Grantlee_Templates PROPERTY
  EXPORT_NAME Templates
)
target_compile_features(Grantlee_Templates
  PRIVATE
    cxx_auto_type
  PUBLIC
    cxx_override
)

if (CMAKE_GENERATOR MATCHES "Visual Studio")

  set_property(TARGET Grantlee_Templates PROPERTY DEBUG_POSTFIX "d")

  foreach(cfg ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${cfg} CFG)
    set_target_properties(Grantlee_Templates
      PROPERTIES
      LIBRARY_OUTPUT_DIRECTORY_${CFG} "${CMAKE_CURRENT_BINARY_DIR}"
      RUNTIME_OUTPUT_DIRECTORY_${CFG} "${CMAKE_CURRENT_BINARY_DIR}"
      )
  endforeach()
endif()
target_compile_definitions(Grantlee_Templates
  PRIVATE
    PLUGINS_PREFER_DEBUG_POSTFIX=$<CONFIG:Debug>
)

if (Qt5Qml_FOUND OR Qt6Qml_FOUND)
  set(scriptabletags_FILES
    scriptablecontext.cpp
    scriptablefilterexpression.cpp
    scriptablenode.cpp
    scriptableparser.cpp
    scriptablesafestring.cpp
    scriptabletags.cpp
    scriptabletemplate.cpp
    scriptablevariable.cpp
    scriptablefilter.cpp
    )

  foreach(file ${scriptabletags_FILES})
    list(APPEND scriptabletags_SRCS ${CMAKE_SOURCE_DIR}/templates/scriptabletags/${file})
  endforeach()

  target_sources(Grantlee_Templates PRIVATE ${scriptabletags_SRCS})
  target_include_directories(Grantlee_Templates PRIVATE ../scriptabletags)
  if (GRANTLEE_BUILD_WITH_QT6)
    target_link_libraries(Grantlee_Templates
      PRIVATE Qt6::Qml
    )
  else()
    target_link_libraries(Grantlee_Templates
      PRIVATE Qt5::Qml
    )
  endif()
endif()

if (BUILD_TESTS)
  set(GRANTLEE_TESTS_EXPORT "GRANTLEE_TEMPLATES_EXPORT")
endif()

configure_file(grantlee_test_export.h.in "${CMAKE_CURRENT_BINARY_DIR}/grantlee_test_export.h")

if (GRANTLEE_BUILD_WITH_QT6)
  target_link_libraries(Grantlee_Templates
    PUBLIC Qt6::Core
  )
else()
  target_link_libraries(Grantlee_Templates
    PUBLIC Qt5::Core
  )
endif()

set_target_properties(Grantlee_Templates PROPERTIES
  VERSION    ${Grantlee5_VERSION}
  SOVERSION  ${Grantlee5_VERSION_MAJOR}
)

install(TARGETS Grantlee_Templates EXPORT grantlee_targets
  RUNTIME DESTINATION bin COMPONENT Templates
  LIBRARY DESTINATION ${LIB_INSTALL_DIR} COMPONENT Templates
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT Templates
  INCLUDES DESTINATION include
)

install(FILES
  abstractlocalizer.h
  cachingloaderdecorator.h
  context.h
  engine.h
  exception.h
  filter.h
  filterexpression.h
  ${CMAKE_CURRENT_BINARY_DIR}/grantlee_templates_export.h
  ${CMAKE_CURRENT_BINARY_DIR}/grantlee_version.h
  metatype.h
  node.h
  outputstream.h
  parser.h
  qtlocalizer.h
  rendercontext.h
  safestring.h
  taglibraryinterface.h
  template.h
  templateloader.h
  typeaccessor.h
  token.h
  util.h
  variable.h
  DESTINATION include/grantlee COMPONENT Templates
)

install(FILES
  grantlee_templates.h
  DESTINATION include COMPONENT Templates
)

=== templates/tests/CMakeLists.txt ===
if (GRANTLEE_BUILD_WITH_QT6)
  find_package(Qt6Test 6.0.0 REQUIRED)
else()
  find_package(Qt5Test 5.2.0 REQUIRED)
endif()

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

set( GRANTLEE_PLUGIN_PATH "${CMAKE_BINARY_DIR}/" )

configure_file(grantlee_paths.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/grantlee_paths.h)

if (GRANTLEE_BUILD_WITH_QT6)
  find_package(Qt6LinguistTools QUIET)
else()
  find_package(Qt5LinguistTools QUIET)
endif()
if (Qt5LinguistTools_FOUND OR Qt6LinguistTools_FOUND)
  set(TESTS_LOCALES "fr_FR" "de_DE")

  if (GRANTLEE_BUILD_WITH_QT6)
    set(QT_LUPDATE_EXECUTABLE Qt6::lupdate)
    set(QT_LRELEASE_EXECUTABLE Qt6::lrelease)
  else()
    set(QT_LUPDATE_EXECUTABLE Qt5::lupdate)
    set(QT_LRELEASE_EXECUTABLE Qt5::lrelease)
  endif()

  set(LINGUIST_TS_ARGS COMMAND "${QT_LUPDATE_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/test_input.cpp" "-ts")

  foreach(TESTS_LOCALE ${TESTS_LOCALES})
      set( LINGUIST_TS_ARGS ${LINGUIST_TS_ARGS} "${CMAKE_CURRENT_SOURCE_DIR}/test_${TESTS_LOCALE}.ts" )
  endforeach()

  add_custom_target(test_l10n
    ${LINGUIST_TS_ARGS}
  )

  set( LINGUIST_QM_ARGS COMMAND "${QT_LRELEASE_EXECUTABLE}" )

  foreach(TESTS_LOCALE ${TESTS_LOCALES})
      set( generate_QMs ${generate_QMs} ${LINGUIST_QM_ARGS} "${CMAKE_CURRENT_SOURCE_DIR}/test_${TESTS_LOCALE}.ts" "-qm" "${CMAKE_CURRENT_BINARY_DIR}/test_${TESTS_LOCALE}.qm" )
  endforeach()

  add_custom_command(
    OUTPUT test_de_DE.qm test_fr_FR.qm
    ${generate_QMs}
    DEPENDS test_de_DE.ts test_fr_FR.ts
  )

  set(QM_FILES "
<qresource>
    <file alias=\"test_de_DE.qm\">${CMAKE_CURRENT_BINARY_DIR}/test_de_DE.qm</file>
    <file alias=\"test_fr_FR.qm\">${CMAKE_CURRENT_BINARY_DIR}/test_fr_FR.qm</file>
</qresource>")
endif()

configure_file(testresource.qrc.cmake "${CMAKE_CURRENT_BINARY_DIR}/testresource.qrc")

set (_rcc_file "${CMAKE_CURRENT_BINARY_DIR}/testresource.qrc")

if (GRANTLEE_BUILD_WITH_QT6)
  qt6_add_resources(_testresource_rcc_src ${_rcc_file} OPTIONS -root "/" )
else()
  qt5_add_resources(_testresource_rcc_src ${_rcc_file} OPTIONS -root "/" )
endif()

add_library(template_test_builtins STATIC coverageobject.cpp
  coverageobject.cpp
  ${_testresource_rcc_src}
)
if (GRANTLEE_BUILD_WITH_QT6)
  target_link_libraries(template_test_builtins Qt6::Test)
else()
  target_link_libraries(template_test_builtins Qt5::Test)
endif()
target_compile_features(template_test_builtins PUBLIC cxx_auto_type)

macro(grantlee_templates_unit_tests)
  foreach(_testname ${ARGN})
    add_executable(${_testname}_exec
                  ${_testname}.cpp
    )
    add_test(${_testname} ${_testname}_exec )
    target_link_libraries(${_testname}_exec Grantlee5::Templates template_test_builtins)

    if (Qt6Qml_FOUND)
      target_compile_definitions(${_testname}_exec PRIVATE HAVE_QTQML_LIB)
    endif()

    set_property(GLOBAL APPEND PROPERTY TEST_COVERAGE "${CMAKE_CURRENT_BINARY_DIR}/${_testname}_exec" )
  endforeach(_testname)
endmacro()

grantlee_templates_unit_tests(
  testsafestring
  testbuiltins
  testloadertags
  testdefaulttags
  testcachingloader
  testfilters
  testgenerictypes
  testgenericcontainers
)

if (Qt5Qml_FOUND OR Qt6Qml_FOUND)
  grantlee_templates_unit_tests(
    testscriptabletags
  )
endif()

if (Qt5LinguistTools_FOUND OR Qt6LinguistTools_FOUND)
  grantlee_templates_unit_tests(
    testinternationalization
  )
  if ("x${CMAKE_CXX_COMPILER_ID}x" MATCHES "xMSVCx")
    target_compile_options(testinternationalization_exec PRIVATE "/utf-8")
  endif()
endif()

=== textdocument/lib/CMakeLists.txt ===

add_library(Grantlee_TextDocument SHARED
  bbcodebuilder.cpp
  markupdirector.cpp
  plaintextmarkupbuilder.cpp
  texthtmlbuilder.cpp
  mediawikimarkupbuilder.cpp

  # Help IDEs find some non-compiled files.
  abstractmarkupbuilder.h
  grantlee_textdocument.h
  markupdirector_p.h
)
generate_export_header(Grantlee_TextDocument)
add_library(Grantlee::TextDocument ALIAS Grantlee_TextDocument)
set_property(TARGET Grantlee_TextDocument PROPERTY
  EXPORT_NAME TextDocument
)
target_compile_features(Grantlee_TextDocument
  PRIVATE
    cxx_auto_type
  PUBLIC
    cxx_override
)
if (CMAKE_GENERATOR MATCHES "Visual Studio")
  set_property(TARGET Grantlee_TextDocument PROPERTY DEBUG_POSTFIX "d")

  foreach(cfg ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${cfg} CFG)
    set_target_properties(Grantlee_TextDocument
      PROPERTIES
      LIBRARY_OUTPUT_DIRECTORY_${CFG} "${CMAKE_CURRENT_BINARY_DIR}"
      RUNTIME_OUTPUT_DIRECTORY_${CFG} "${CMAKE_CURRENT_BINARY_DIR}"
      )
  endforeach()
endif()

if (GRANTLEE_BUILD_WITH_QT6)
  target_link_libraries(Grantlee_TextDocument
    PUBLIC Qt6::Gui
  )
else()
  target_link_libraries(Grantlee_TextDocument
    PUBLIC Qt5::Gui
  )
endif()

set_target_properties(Grantlee_TextDocument PROPERTIES
  VERSION    ${Grantlee5_VERSION}
  SOVERSION  ${Grantlee5_VERSION_MAJOR}
)

install(TARGETS Grantlee_TextDocument EXPORT grantlee_targets
  RUNTIME DESTINATION bin COMPONENT TextDocument
  LIBRARY DESTINATION ${LIB_INSTALL_DIR} COMPONENT TextDocument
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT TextDocument
  INCLUDES DESTINATION include
)

install(FILES
  abstractmarkupbuilder.h
  bbcodebuilder.h
  markupdirector.h
  plaintextmarkupbuilder.h
  texthtmlbuilder.h
  mediawikimarkupbuilder.h
  ${CMAKE_CURRENT_BINARY_DIR}/grantlee_textdocument_export.h
  DESTINATION include/grantlee COMPONENT TextDocument
)

install(FILES
  grantlee_textdocument.h
  DESTINATION include COMPONENT TextDocument
)

=== textdocument/tests/CMakeLists.txt ===

if (GRANTLEE_BUILD_WITH_QT6)
    find_package(Qt6Test 6.0.0 REQUIRED)
else()
    find_package(Qt5Test 5.2.0 REQUIRED)
endif()

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

add_library(textdocument_test_builtins STATIC
  coverageobject.cpp
)
if (GRANTLEE_BUILD_WITH_QT6)
    target_link_libraries(textdocument_test_builtins Qt6::Test)
else()
    target_link_libraries(textdocument_test_builtins Qt5::Test)
endif()
target_compile_features(textdocument_test_builtins PUBLIC cxx_auto_type)

macro(GRANTLEE_TEXTDOCUMENT_UNIT_TESTS)
  foreach(_testname ${ARGN})
    add_executable(${_testname}_exec ${_testname}.cpp)
    add_test(${_testname} ${_testname}_exec )
    target_link_libraries(${_testname}_exec Grantlee::TextDocument textdocument_test_builtins)
    set_property(GLOBAL APPEND PROPERTY TEST_COVERAGE "${CMAKE_CURRENT_BINARY_DIR}/${_testname}_exec" )
  endforeach(_testname)
endmacro(GRANTLEE_TEXTDOCUMENT_UNIT_TESTS)

grantlee_textdocument_unit_tests(
  htmlbuildertest
  plainmarkupbuildertest
)

if (NOT GRANTLEE_BUILD_WITH_QT6)
  target_compile_definitions(plainmarkupbuildertest_exec PRIVATE QT_TESTCASE_BUILDDIR="${CMAKE_BINARY_DIR}")
endif()

=== debian/changelog ===
grantlee5 (5.3.1-6) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Use new Extra team name and email as the maintainer.
  * Build with hardening=+all build hardening flag.
  * Bump Standards-Version to 4.7.3, no change required.
  * Switch to debian/watch format version 5.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 15 Feb 2026 12:53:51 +0100

grantlee5 (5.3.1-5) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Add -Wl,-z,gcs-report-dynamic=none to the LDFLAGS on arm64.
    (Closes: #1110454)

 -- Pino Toscano <pino@debian.org>  Fri, 10 Oct 2025 20:07:55 +0200

grantlee5 (5.3.1-4) unstable; urgency=medium

  * Drop the support for the dead ia64 architecture:
    - drop ia64 from the list of architectures where the testsuite fails
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 05 Apr 2025 09:38:50 +0200

grantlee5 (5.3.1-3) unstable; urgency=medium

  * Upload to unstable (see #1052252).
  * Remove hppa from the list of architectures where the testsuite fails.

 -- Pino Toscano <pino@debian.org>  Sat, 30 Sep 2023 07:40:38 +0200

grantlee5 (5.3.1-2) experimental; urgency=medium

  * Build with -ffloat-store on i386 architectures to fix rounding issues with
    double/qreal.
  * Properly register MetaEnumVariable for comparison; should hopefully fix the
    enum tests on some architectures; patch register-comparator.diff
    - update symbols files accordingly
  * Run xvfb-run with -a, to avoid potential collisions.

 -- Pino Toscano <pino@debian.org>  Sat, 12 Aug 2023 12:29:16 +0200

grantlee5 (5.3.1-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from 5.2.0-5:
    - switch the grantlee5-templates-5-2 provides of libgrantlee-templates5 to
      grantlee5-templates-5-3
    - remove the upstream signing key, as the tarballs are generated by github

 -- Pino Toscano <pino@debian.org>  Sat, 05 Aug 2023 12:40:31 +0200

grantlee5 (5.2.0-5) unstable; urgency=medium

  * grantlee.org is gone, so:
    - switch Homepage & Source to https://github.com/steveire/grantlee
    - switch watch to use the github tags
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Ship a new dh_grantlee tool in libgrantlee5-dev to help ensuring packages
    that install grantlee plugins depend on the right version of
    libgrantlee-templates5:
    - add the grantlee5-templates-5-2 provides to libgrantlee-templates5,
    - add the dh-sequence-grantlee provides to libgrantlee5-dev
    - create the manpages for it at build time using pod2man
    - use the ${perl:Depends} substvar in libgrantlee5-dev

 -- Pino Toscano <pino@debian.org>  Sat, 05 Aug 2023 11:25:48 +0200

=== debian/control ===
Source: grantlee5
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake (>= 3.5~),
               debhelper-compat (= 13),
               pkg-kde-tools,
               qtbase5-dev (>= 5.4),
               qtdeclarative5-dev (>= 5.4),
               qttools5-dev (>= 5.4),
               qttools5-dev-tools (>= 5.4),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.3
Homepage: https://github.com/steveire/grantlee
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/grantlee
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/grantlee.git

Package: libgrantlee-textdocument5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Grantlee templating library for Qt - TextDocument
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the TextDocument Grantlee library.

Package: libgrantlee-templates5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: grantlee5-templates-5-3
Description: Grantlee templating library for Qt - Templates
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the Templates Grantlee library. It also contains the
 standard plugins.

Package: libgrantlee5-dev
Section: libdevel
Architecture: any
Depends: libgrantlee-templates5 (= ${binary:Version}),
         libgrantlee-textdocument5 (= ${binary:Version}),
         qtbase5-dev (>= 5.4),
         ${misc:Depends},
         ${perl:Depends},
Breaks: libgrantlee-dev (<= 5~)
Replaces: libgrantlee-dev (<= 5~)
Provides: dh-sequence-grantlee
Description: Grantlee templating library development files
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the development files for building applications
 using grantlee.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Disable fixfilepath, as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_CXXFLAGS_MAINT_APPEND = -ffloat-store
endif

ifeq ($(DEB_TARGET_ARCH),arm64)
  export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,gcs-report-dynamic=none
endif

testsuite_failing_archs := sparc64
ifneq (,$(filter $(DEB_HOST_ARCH),$(testsuite_failing_archs)))
  fail_param := || true
endif

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

execute_after_dh_auto_build-arch:
	pod2man debian/dh/dh_grantlee > dh_grantlee.1

override_dh_auto_test:
	xvfb-run -a dh_auto_test $(fail_param)

=== debian/watch ===
Version: 5
Template: GitHub
Owner: steveire
Project: grantlee
